/*
 * MosP - Mind Open Source Project         http://www.mosp.jp/
 * Copyright (C) 1987-2009 MIND Co., Ltd.  http://www.e-mind.co.jp/
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package jp.mosp.payroll.system.vo;

import java.util.List;

import javax.servlet.http.HttpServletRequest;

import jp.mosp.payroll.base.PayrollConst;
import jp.mosp.payroll.base.PayrollVo;
import jp.mosp.payroll.dto.DetailDto;
import jp.mosp.payroll.system.action.DetailListAction;

/**
 * 明細設定一覧画面における情報を扱う。<br><br>
 */
public class DetailListVo extends PayrollVo {
	
	private static final long serialVersionUID = 1654283456674729802L;
	
	// フィールド
	private String pltType  ;
	private String txtAbbr  ;
	private String pltDelete;
	
	// フィールド(一覧)
	private String[] aryType  ;
	private String[] aryCode  ;
	private String[] aryName  ;
	private String[] aryAbbr  ;
	private String[] aryDelete;
	
	// プルダウン
	private String[][] pitType;
	
	/**
	 * パラメータ名(区分)。
	 */
	public static final String PRM_PLT_TYPE = "pltType";
	
	/**
	 * パラメータ名(略称)。
	 */
	public static final String PRM_TXT_ABBR = "txtAbbr";
	
	/**
	 * パラメータ名(削除フラグ)。
	 */
	public static final String PRM_PLT_DELETE = "pltDelete";
	
	/**
	 * 項目長(明細略称)
	 */
	public static final int LEN_ABBR = PayrollConst.LEN_DETAIL_ABBR;
	
	/**
	 * {@link PayrollVo#PayrollVo()}を実行する。
	 */
	public DetailListVo() {
		super();
		aryType   = new String[0];
		aryCode   = new String[0];
		aryName   = new String[0];
		aryAbbr   = new String[0];
		aryDelete = new String[0];
		setPageCommand(DetailListAction.CMD_PAGE);
		setSortKey("1");
	}
	
	/**
	 * 項目名称を設定する。
	 */
	@Override
	protected void setFieldsName() {
		super.setFieldsName();
		pitType = getDetailTypeArray();
	}
	
	/* (non-Javadoc)
	 * @see jp.mosp.payroll.base.PayrollVo#setSubTitle()
	 */
	@Override
	protected void setSubTitle() {
		super.setSubTitle();
		subTitle = getName("P_DETAIL") + getName("P_SETTING");
		addAryMenu("P1002", getName("P_PAYMENT") +
				getName("P_CALCULATE") + getName("C_MASTER") + getName("C_TO"));
	}
	
	/**
	 * リクエストからパラメータを取得、設定する。
	 * @param request リクエスト
	 */
	public void setParams(HttpServletRequest request) {
		pltType   = request.getParameter(PRM_PLT_TYPE  );
		txtAbbr   = request.getParameter(PRM_TXT_ABBR  );
		pltDelete = request.getParameter(PRM_PLT_DELETE);
	}
	
	/**
	 * フィールドを設定する。<br>
	 * @param list DTOリスト
	 */
	public void setFields(List<?> list) {
		// データ総数の取得
		count = list.size();
		// 配列の初期化
		aryType   = new String[count];
		aryCode   = new String[count];
		aryName   = new String[count];
		aryAbbr   = new String[count];
		aryDelete = new String[count];
		// データの設定
		for (int i = 0; i < list.size(); i++) {
			DetailDto dto = (DetailDto)list.get(i);
			aryType  [i] = getCodeName(pltType, pitType);
			aryCode  [i] = dto.getDetailCode();
			aryName  [i] = dto.getDetailName();
			aryAbbr  [i] = dto.getDetailAbbr();
			aryDelete[i] = getDeleteName(dto.getDeleteFlag());
		}
	}

	/**
	 * 略称(一覧)を取得する。
	 * @param idx インデックス
	 * @return 略称
	 */
	public String getAryAbbr(int idx) {
		return escapeHTML(aryAbbr[idx]);
	}
	
	/**
	 * コード(一覧)を取得する。
	 * @param idx インデックス
	 * @return コード
	 */
	public String getAryCode(int idx) {
		return escapeHTML(aryCode[idx]);
	}
	
	/**
	 * 削除フラグ(一覧)を取得する。
	 * @param idx インデックス
	 * @return 削除フラグ
	 */
	public String getAryDelete(int idx) {
		return escapeHTML(aryDelete[idx]);
	}
	
	/**
	 * 名称(一覧)を取得する。
	 * @param idx インデックス
	 * @return 名称
	 */
	public String getAryName(int idx) {
		return escapeHTML(aryName[idx]);
	}
	
	/**
	 * 区分(一覧)を取得する。
	 * @param idx インデックス
	 * @return 区分
	 */
	public String getAryType(int idx) {
		return escapeHTML(aryType[idx]);
	}
	
	/**
	 * 区分プルダウンアイテムを取得する。
	 * @return 区分プルダウンアイテム
	 */
	public String[][] getPitType() {
		return getAryField(pitType);
	}

	/**
	 * 区分プルダウンアイテムを設定する。
	 * @param pitType 設定する区分プルダウンアイテム
	 */
	public void setPitType(String[][] pitType) {
		this.pitType = getAryField(pitType);
	}

	/**
	 * 削除フラグを取得する。
	 * @return 削除フラグ
	 */
	public String getPltDelete() {
		return pltDelete;
	}

	/**
	 * 削除フラグを設定する。
	 * @param pltDelete 設定する削除フラグ
	 */
	public void setPltDelete(String pltDelete) {
		this.pltDelete = pltDelete;
	}

	/**
	 * 区分を取得する。
	 * @return 区分
	 */
	public String getPltType() {
		return pltType;
	}

	/**
	 * 区分を設定する。
	 * @param pltType 設定する区分
	 */
	public void setPltType(String pltType) {
		this.pltType = pltType;
	}

	/**
	 * 略称を取得する。
	 * @return 略称
	 */
	public String getTxtAbbr() {
		return txtAbbr;
	}

	/**
	 * 略称を設定する。
	 * @param txtAbbr 設定する略称
	 */
	public void setTxtAbbr(String txtAbbr) {
		this.txtAbbr = txtAbbr;
	}

	/**
	 * 略称を取得する。
	 * @return 略称
	 */
	public String getEscTxtAbbr() {
		return escapeHTML(txtAbbr);
	}
	
}
